-- updates for 6.3
    
CREATE TABLE TEMPLATE_MAPPING(
TEMPLATE_ID number(19) NOT NULL,
COLUMN_NAME varchar2(50) NOT NULL,
COL_DESC nvarchar2(255) NOT NULL,
COMPONENT_ID varchar2(50) NOT NULL,
COMPONENT_TYPE varchar2(50) NOT NULL,
CON_ID number(19) NOT NULL,
ITEM_SCHEME_ID number(19) NOT NULL,
PRIMARY KEY (TEMPLATE_ID))
;


ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_ITEM_SCHEME_TEMPLATE FOREIGN KEY (ITEM_SCHEME_ID) REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_CON_ID_TEMPLATE FOREIGN KEY (CON_ID) REFERENCES CONCEPT (CON_ID)
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_COMPONENT_COMMON_TEMPLATE FOREIGN KEY (TEMPLATE_ID) REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

CREATE TABLE TM_TRANSCODING(
TEMPLATE_ID number(19) NOT NULL,
LOCAL_CODE nvarchar2(150) NOT NULL,
DSD_CODE varchar2(150) NOT NULL,
PRIMARY KEY (TEMPLATE_ID,LOCAL_CODE))
;

ALTER TABLE TM_TRANSCODING ADD CONSTRAINT FK_TEMPLATE_TRANSCODING FOREIGN KEY (TEMPLATE_ID) REFERENCES TEMPLATE_MAPPING (TEMPLATE_ID)
ON DELETE CASCADE
;

CREATE TABLE TM_TIME_TRANSCODING(
TEMPLATE_ID number(19) NOT NULL,
FREQ varchar2(5) NOT NULL,
IS_DATE number(10) NOT NULL,
Y_START number(19) NULL,
Y_LENGTH number(19) NULL,
P_START number(19) NULL,
P_LENGTH number(19) NULL,
PRIMARY KEY (TEMPLATE_ID,FREQ))
;

ALTER TABLE TM_TIME_TRANSCODING ADD CONSTRAINT FK_TEMPLATE_TIME FOREIGN KEY (TEMPLATE_ID) REFERENCES TEMPLATE_MAPPING (TEMPLATE_ID)
ON DELETE CASCADE
;
CREATE OR REPLACE PROCEDURE INSERT_TEMPLATE_MAPPING(
p_column_name IN varchar2,
p_col_desc IN nvarchar2,
p_component_id IN varchar2,
p_component_type IN varchar2,
p_con_id IN number,
p_item_scheme_id IN number,
p_pk OUT number)
AS
BEGIN
		INSERT_COMPONENT_COMMON(p_pk => p_pk);
		INSERT INTO TEMPLATE_MAPPING (TEMPLATE_ID,COLUMN_NAME,COL_DESC,COMPONENT_ID,COMPONENT_TYPE,CON_ID,ITEM_SCHEME_ID) VALUES (p_pk, p_column_name, p_col_desc, p_component_id, p_component_type, p_con_id, p_item_scheme_id);
END;
/

;


-- always last
update DB_VERSION SET VERSION = '6.3'
;

